Index: LMDZ4/branches/LMDZ4-dev/libf/bibio/initdynav.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/bibio/initdynav.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/bibio/initdynav.F	(revision 1114)
@@ -5,7 +5,8 @@
 c
       subroutine initdynav(infile,day0,anne0,tstep,t_ops,t_wrt
-     .                     ,nq,fileid)
+     .                     ,fileid)
 
        USE IOIPSL
+       USE infotrac, ONLY : nqtot, ttext
 
       implicit none
@@ -28,5 +29,4 @@
 C      t_ops: frequence de l'operation pour IOIPSL
 C      t_wrt: frequence d'ecriture sur le fichier
-C      nq: nombre de traceurs
 C
 C   Sortie:
@@ -48,5 +48,4 @@
 #include "description.h"
 #include "serre.h"
-#include "advtrac.h"
 
 C   Arguments
@@ -56,5 +55,4 @@
       real tstep, t_ops, t_wrt
       integer fileid
-      integer nq
       integer thoriid, zvertiid
 
@@ -136,5 +134,5 @@
 C  Traceurs
 C
-        DO iq=1,nq
+        DO iq=1,nqtot
           call histdef(fileid, ttext(iq), ttext(iq), '-',
      .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
Index: LMDZ4/branches/LMDZ4-dev/libf/bibio/initfluxsto.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/bibio/initfluxsto.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/bibio/initfluxsto.F	(revision 1114)
@@ -3,5 +3,5 @@
 !
       subroutine initfluxsto
-     .  (infile,tstep,t_ops,t_wrt,nq,
+     .  (infile,tstep,t_ops,t_wrt,
      .                    fileid,filevid,filedid)
 
@@ -27,5 +27,4 @@
 C      t_ops: frequence de l'operation pour IOIPSL
 C      t_wrt: frequence d'ecriture sur le fichier
-C      nq: nombre de traceurs
 C
 C   Sortie:
@@ -55,5 +54,5 @@
       real tstep, t_ops, t_wrt
       integer fileid, filevid,filedid
-      integer nq,ndex(1)
+      integer ndex(1)
       real nivd(1)
 
Index: LMDZ4/branches/LMDZ4-dev/libf/bibio/inithist.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/bibio/inithist.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/bibio/inithist.F	(revision 1114)
@@ -2,8 +2,9 @@
 ! $Header$
 !
-      subroutine inithist(infile,day0,anne0,tstep,t_ops,t_wrt,nq,fileid,
+      subroutine inithist(infile,day0,anne0,tstep,t_ops,t_wrt,fileid,
      .                    filevid)
 
        USE IOIPSL
+       USE infotrac, ONLY : nqtot, ttext
 
       implicit none
@@ -47,5 +48,4 @@
 #include "description.h"
 #include "serre.h"
-#include "advtrac.h"
 
 C   Arguments
@@ -55,5 +55,4 @@
       real tstep, t_ops, t_wrt
       integer fileid, filevid
-      integer nq
 
 C   Variables locales
@@ -154,5 +153,5 @@
 C  Traceurs
 C
-        DO iq=1,nq
+        DO iq=1,nqtot
           call histdef(fileid, ttext(iq),  ttext(iq), '-',
      .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
Index: LMDZ4/branches/LMDZ4-dev/libf/bibio/writedynav.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/bibio/writedynav.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/bibio/writedynav.F	(revision 1114)
@@ -2,8 +2,9 @@
 ! $Header$
 !
-      subroutine writedynav( histid, nq, time, vcov, 
+      subroutine writedynav( histid, time, vcov, 
      ,                          ucov,teta,ppk,phi,q,masse,ps,phis)
 
       USE ioipsl
+      USE infotrac, ONLY : nqtot, ttext
       implicit none
 
@@ -15,5 +16,4 @@
 C   Entree:
 C      histid: ID du fichier histoire
-C      nqmx: nombre maxi de traceurs
 C      time: temps de l'ecriture
 C      vcov: vents v covariants
@@ -45,5 +45,4 @@
 #include "description.h"
 #include "serre.h"
-#include "advtrac.h"
 
 C
@@ -51,10 +50,10 @@
 C
 
-      INTEGER histid, nq
+      INTEGER histid
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) 
       REAL teta(ip1jmp1*llm),phi(ip1jmp1,llm),ppk(ip1jmp1*llm)                  
       REAL ps(ip1jmp1),masse(ip1jmp1,llm)                   
       REAL phis(ip1jmp1)                  
-      REAL q(ip1jmp1,llm,nq)
+      REAL q(ip1jmp1,llm,nqtot)
       integer time
 
@@ -119,5 +118,5 @@
 C  Traceurs
 C
-        DO iq=1,nq
+        DO iq=1,nqtot
           call histwrite(histid, ttext(iq), itau_w, q(:,:,iq), 
      .                   iip1*jjp1*llm, ndex3d)
Index: LMDZ4/branches/LMDZ4-dev/libf/bibio/writehist.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/bibio/writehist.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/bibio/writehist.F	(revision 1114)
@@ -2,8 +2,9 @@
 ! $Header$
 !
-      subroutine writehist( histid, histvid, nq, time, vcov, 
+      subroutine writehist( histid, histvid, time, vcov, 
      ,                          ucov,teta,phi,q,masse,ps,phis)
 
       USE ioipsl
+      USE infotrac, ONLY : nqtot, ttext
       implicit none
 
@@ -16,5 +17,4 @@
 C      histid: ID du fichier histoire
 C      histvid:ID du fichier histoire pour les vents V (appele a disparaitre)
-C      nqmx: nombre maxi de traceurs
 C      time: temps de l'ecriture
 C      vcov: vents v covariants
@@ -46,5 +46,4 @@
 #include "description.h"
 #include "serre.h"
-#include "advtrac.h"
 
 C
@@ -52,10 +51,10 @@
 C
 
-      INTEGER histid, nq, histvid
+      INTEGER histid, histvid
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) 
       REAL teta(ip1jmp1,llm),phi(ip1jmp1,llm)                   
       REAL ps(ip1jmp1),masse(ip1jmp1,llm)                   
       REAL phis(ip1jmp1)                  
-      REAL q(ip1jmp1,llm,nq)
+      REAL q(ip1jmp1,llm,nqtot)
       integer time
 
@@ -102,5 +101,5 @@
 C  Traceurs
 C
-        DO iq=1,nq
+        DO iq=1,nqtot
           call histwrite(histid, ttext(iq), itau_w, q(:,:,iq), 
      .                   iip1*jjp1*llm, ndexu)
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/addfi.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/addfi.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/addfi.F	(revision 1114)
@@ -2,7 +2,9 @@
 ! $Header$
 !
-      SUBROUTINE addfi(nq, pdt, leapf, forward,
+      SUBROUTINE addfi(pdt, leapf, forward,
      S          pucov, pvcov, pteta, pq   , pps ,
      S          pdufi, pdvfi, pdhfi,pdqfi, pdpfi  )
+
+      USE infotrac, ONLY : nqtot
       IMPLICIT NONE
 c
@@ -52,13 +54,11 @@
 c    -----------
 c
-      INTEGER nq
-
       REAL pdt
 c
       REAL pvcov(ip1jm,llm),pucov(ip1jmp1,llm)
-      REAL pteta(ip1jmp1,llm),pq(ip1jmp1,llm,nq),pps(ip1jmp1)
+      REAL pteta(ip1jmp1,llm),pq(ip1jmp1,llm,nqtot),pps(ip1jmp1)
 c
       REAL pdvfi(ip1jm,llm),pdufi(ip1jmp1,llm)
-      REAL pdqfi(ip1jmp1,llm,nq),pdhfi(ip1jmp1,llm),pdpfi(ip1jmp1)
+      REAL pdqfi(ip1jmp1,llm,nqtot),pdhfi(ip1jmp1,llm),pdpfi(ip1jmp1)
 c
       LOGICAL leapf,forward
@@ -125,5 +125,5 @@
       ENDDO
 
-      DO iq = 3, nq
+      DO iq = 3, nqtot
          DO k = 1,llm
             DO j = 1,ip1jmp1
@@ -148,5 +148,5 @@
 
 
-      DO iq = 1, nq
+      DO iq = 1, nqtot
         DO  k    = 1, llm
           DO  ij   = 1, iim
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/advtrac.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/advtrac.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/advtrac.F	(revision 1114)
@@ -15,4 +15,6 @@
 c            M.A Filiberti (04/2002)
 c
+      USE infotrac
+
       IMPLICIT NONE
 c
@@ -28,5 +30,4 @@
 #include "ener.h"
 #include "description.h"
-#include "advtrac.h"
 
 c-------------------------------------------------------------------
@@ -39,5 +40,5 @@
       INTEGER iapptrac
       REAL pbaru(ip1jmp1,llm),pbarv(ip1jm,llm)
-      REAL q(ip1jmp1,llm,nqmx),masse(ip1jmp1,llm)
+      REAL q(ip1jmp1,llm,nqtot),masse(ip1jmp1,llm)
       REAL p( ip1jmp1,llmp1 ),teta(ip1jmp1,llm)
       REAL pk(ip1jmp1,llm)
@@ -52,7 +53,4 @@
       REAL pbarug(ip1jmp1,llm),pbarvg(ip1jm,llm),wg(ip1jmp1,llm) 
       REAL (kind=kind(1.d0)) :: t_initial, t_final, tps_cpu
-      real cpuadv(nqmx)
-      common/cpuadv/cpuadv
-
       INTEGER iadvtr
       INTEGER ij,l,iq,iiq
@@ -69,5 +67,5 @@
       REAL psppm(iim,jjp1) ! pression  au sol
       REAL unatppm(iim,jjp1,llm),vnatppm(iim,jjp1,llm)
-      REAL qppm(iim*jjp1,llm,nqmx)
+      REAL qppm(iim*jjp1,llm,nqtot)
       REAL fluxwppm(iim,jjp1,llm)
       REAL apppm(llmp1), bpppm(llmp1)
@@ -153,5 +151,5 @@
 c     Appel des sous programmes d'advection
 c-----------------------------------------------------------
-      do iq=1,nqmx
+      do iq=1,nqtot
 c        call clock(t_initial)
         if(iadv(iq) == 0) cycle 
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/caladvtrac.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/caladvtrac.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/caladvtrac.F	(revision 1114)
@@ -8,4 +8,5 @@
      *                   flxw, pk)
 c
+      USE infotrac
       IMPLICIT NONE
 c
@@ -24,10 +25,9 @@
 #include "comconst.h"
 #include "control.h"
-#include "advtrac.h"
 
 c   Arguments:
 c   ----------
       REAL pbaru( ip1jmp1,llm ),pbarv( ip1jm,llm),masse(ip1jmp1,llm)
-      REAL p( ip1jmp1,llmp1),q( ip1jmp1,llm,nqmx),dq( ip1jmp1,llm,2 )
+      REAL p( ip1jmp1,llmp1),q( ip1jmp1,llm,nqtot),dq( ip1jmp1,llm,2 )
       REAL teta( ip1jmp1,llm),pk( ip1jmp1,llm)
       REAL               :: flxw(ip1jmp1,llm)
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/calfis.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/calfis.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/calfis.F	(revision 1114)
@@ -4,6 +4,5 @@
 C
 C
-      SUBROUTINE calfis(nq,
-     $                  lafin,
+      SUBROUTINE calfis(lafin,
      $                  rdayvrai,
      $                  heure,
@@ -32,4 +31,5 @@
 c    Auteur :  P. Le Van, F. Hourdin 
 c   .........
+      USE infotrac
 
       IMPLICIT NONE
@@ -90,7 +90,6 @@
 #include "paramet.h"
 #include "temps.h"
-#include "advtrac.h"
-
-      INTEGER ngridmx,nq
+
+      INTEGER ngridmx
       PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )
 
@@ -109,5 +108,5 @@
       REAL pteta(iip1,jjp1,llm)
       REAL pmasse(iip1,jjp1,llm)
-      REAL pq(iip1,jjp1,llm,nqmx)
+      REAL pq(iip1,jjp1,llm,nqtot)
       REAL pphis(iip1,jjp1)
       REAL pphi(iip1,jjp1,llm)
@@ -116,5 +115,5 @@
       REAL pducov(iip1,jjp1,llm)
       REAL pdteta(iip1,jjp1,llm)
-      REAL pdq(iip1,jjp1,llm,nqmx)
+      REAL pdq(iip1,jjp1,llm,nqtot)
 c
       REAL pps(iip1,jjp1)
@@ -125,5 +124,5 @@
       REAL pdufi(iip1,jjp1,llm)
       REAL pdhfi(iip1,jjp1,llm)
-      REAL pdqfi(iip1,jjp1,llm,nqmx)
+      REAL pdqfi(iip1,jjp1,llm,nqtot)
       REAL pdpsfi(iip1,jjp1)
 
@@ -142,5 +141,5 @@
 c
       REAL zufi(ngridmx,llm), zvfi(ngridmx,llm)
-      REAL ztfi(ngridmx,llm),zqfi(ngridmx,llm,nqmx)
+      REAL ztfi(ngridmx,llm),zqfi(ngridmx,llm,nqtot)
 c
       REAL pcvgu(ngridmx,llm), pcvgv(ngridmx,llm)
@@ -148,5 +147,5 @@
 c
       REAL zdufi(ngridmx,llm),zdvfi(ngridmx,llm)
-      REAL zdtfi(ngridmx,llm),zdqfi(ngridmx,llm,nqmx)
+      REAL zdtfi(ngridmx,llm),zdqfi(ngridmx,llm,nqtot)
       REAL zdpsrf(ngridmx)
 c
@@ -275,5 +274,5 @@
 c   ---------------
 c
-      DO iq=1,nq
+      DO iq=1,nqtot
           iiq=niadv(iq) 
          DO l=1,llm
@@ -444,5 +443,4 @@
       CALL physiq (ngridmx,
      .             llm,
-     .             nq,
      .             debut,
      .             lafin,
@@ -505,5 +503,5 @@
 c   ---------------------
 
-      DO iq=1,nqmx
+      DO iq=1,nqtot
          DO l=1,llm
             DO i=1,iip1
@@ -526,5 +524,5 @@
       pdqfi=0.
 C
-      DO iq=1,nq
+      DO iq=1,nqtot
          iiq=niadv(iq)
          DO l=1,llm
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/create_etat0_limit.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/create_etat0_limit.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/create_etat0_limit.F	(revision 1114)
@@ -5,5 +5,5 @@
        USE dimphy
        USE comgeomphy
-
+       USE infotrac
 c
 c
@@ -28,29 +28,18 @@
 #include "paramet.h"
 #include "indicesol.h"
-#include "advtrac.h"
 #include  "control.h"
       REAL :: masque(iip1,jjp1)
 !      REAL :: pctsrf(iim*(jjm-1)+2, nbsrf)
 
-c initialisation traceurs
-      hadv_flg(:) = 0.
-      vadv_flg(:) = 0.
-      conv_flg(:) = 0.
-      pbl_flg(:)  = 0. 
-      tracnam(:)  = '        ' 
-      nprath = 1
-      nbtrac = 0
-      mmt_adj(:,:,:,:) = 1
-
       IF (config_inca /= 'none') THEN
 #ifdef INCA
          call init_const_lmdz(
-     $        nbtrac,anneeref,dayref,
+     $        nbtr,anneeref,dayref,
      $        iphysiq, day_step,nday)
 #endif
-         print *, 'nbtrac =' , nbtrac 
+         print *, 'nbtr =' , nbtr 
       END IF
 
-      CALL Init_Phys_lmdz(iim,jjp1,llm,nqmx-2,1,(jjm-1)*iim+2)
+      CALL Init_Phys_lmdz(iim,jjp1,llm,1,(jjm-1)*iim+2)
       call InitComgeomphy
 
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/dynetat0.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/dynetat0.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/dynetat0.F	(revision 1114)
@@ -2,6 +2,8 @@
 ! $Header$
 !
-      SUBROUTINE dynetat0(fichnom,nq,vcov,ucov,
+      SUBROUTINE dynetat0(fichnom,vcov,ucov,
      .                    teta,q,masse,ps,phis,time)
+
+      USE infotrac
       IMPLICIT NONE
 
@@ -32,5 +34,4 @@
 #include "serre.h"
 #include "logic.h"
-#include "advtrac.h"
 
 c   Arguments:
@@ -38,7 +39,6 @@
 
       CHARACTER*(*) fichnom
-      INTEGER nq
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm),teta(ip1jmp1,llm)
-      REAL q(ip1jmp1,llm,nq),masse(ip1jmp1,llm)
+      REAL q(ip1jmp1,llm,nqtot),masse(ip1jmp1,llm)
       REAL ps(ip1jmp1),phis(ip1jmp1)
 
@@ -315,6 +315,6 @@
 
 
-      IF(nq.GE.1) THEN
-      DO iq=1,nq
+      IF(nqtot.GE.1) THEN
+      DO iq=1,nqtot
         ierr =  NF_INQ_VARID (nid, tname(iq), nvarid)
         IF (ierr .NE. NF_NOERR) THEN
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/dynredem.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/dynredem.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/dynredem.F	(revision 1114)
@@ -3,6 +3,7 @@
 !
 c
-      SUBROUTINE dynredem0(fichnom,iday_end,phis,nq)
+      SUBROUTINE dynredem0(fichnom,iday_end,phis)
       USE IOIPSL
+      USE infotrac
       IMPLICIT NONE
 c=======================================================================
@@ -22,5 +23,4 @@
 #include "description.h"
 #include "serre.h"
-#include "advtrac.h"
 
 c   Arguments:
@@ -29,5 +29,4 @@
       REAL phis(ip1jmp1)
       CHARACTER*(*) fichnom
-      INTEGER nq
 
 c   Local:
@@ -458,6 +457,6 @@
       dims4(3) = idim_s
       dims4(4) = idim_tim
-      IF(nq.GE.1) THEN
-      DO iq=1,nq
+      IF(nqtot.GE.1) THEN
+      DO iq=1,nqtot
 cIM 220306 BEG
 #ifdef NC_DOUBLE
@@ -508,5 +507,6 @@
       END
       SUBROUTINE dynredem1(fichnom,time,
-     .                     vcov,ucov,teta,q,nq,masse,ps)
+     .                     vcov,ucov,teta,q,masse,ps)
+      USE infotrac
       IMPLICIT NONE
 c=================================================================
@@ -519,13 +519,12 @@
 #include "comvert.h"
 #include "comgeom.h"
-#include "advtrac.h"
 #include "temps.h"
 #include "control.h"
 
-      INTEGER nq, l
+      INTEGER l
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) 
       REAL teta(ip1jmp1,llm)                   
       REAL ps(ip1jmp1),masse(ip1jmp1,llm)                   
-      REAL q(ip1jmp1,llm,nq)
+      REAL q(ip1jmp1,llm,nqtot)
       CHARACTER*(*) fichnom
      
@@ -633,6 +632,6 @@
       END IF
 
-      IF(nq.GE.1) THEN
-      do iq=1,nq 
+      IF(nqtot.GE.1) THEN
+      do iq=1,nqtot 
 
          IF (config_inca == 'none') THEN
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/etat0_netcdf.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/etat0_netcdf.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/etat0_netcdf.F	(revision 1114)
@@ -9,4 +9,5 @@
       USE ioipsl
       USE dimphy
+      USE infotrac
       USE fonte_neige_mod
       USE pbl_surface_mod
@@ -33,11 +34,12 @@
       LOGICAL interbar
       REAL :: latfi(klon), lonfi(klon)
-      REAL :: orog(iip1,jjp1), rugo(iip1,jjp1), masque(iip1,jjp1),
-     . psol(iip1, jjp1), phis(iip1, jjp1)
+      REAL :: orog(iip1,jjp1), rugo(iip1,jjp1), masque(iip1,jjp1)
+      REAL :: psol(iip1, jjp1), phis(iip1, jjp1)
       REAL :: p3d(iip1, jjp1, llm+1)
       REAL :: uvent(iip1, jjp1, llm)
       REAL :: vvent(iip1, jjm, llm)
       REAL :: t3d(iip1, jjp1, llm), tpot(iip1, jjp1, llm)
-      REAL :: q3d(iip1, jjp1, llm,nqmx), qsat(iip1, jjp1, llm)
+      REAL, ALLOCATABLE, DIMENSION(:,:,:,:) :: q3d
+      REAL :: qsat(iip1, jjp1, llm)
       REAL :: tsol(klon), qsol(klon), sn(klon)
       REAL :: tsolsrf(klon,nbsrf), qsolsrf(klon,nbsrf),snsrf(klon,nbsrf) 
@@ -64,5 +66,4 @@
       !
       INTEGER :: i,j, ig, l, ji,ii1,ii2
-      INTEGER :: nq
       REAL :: xpi
       !
@@ -165,7 +166,14 @@
       print*,'dtvr',dtvr
 
+
+
       CALL inicons0()
       CALL inigeom()
-      !
+
+! Initialisation pour traceurs
+      CALL infotrac_init
+      ALLOCATE(q3d(iip1,jjp1,llm,nqtot))
+
+
       CALL inifilr()
       CALL phys_state_var_init()
@@ -624,6 +632,4 @@
       phis(iip1,:) = phis(1,:)
 
-C init pour traceurs
-      call iniadvtrac(nq)
 C Ecriture
       CALL inidissip( lstardis, nitergdiv, nitergrot, niterh   ,
@@ -649,7 +655,7 @@
      *                phi,w, pbaru,pbarv,time+iday-dayref   )
        print*,'sortie caldyn0'     
-      CALL dynredem0("start.nc",dayref,phis,nqmx)
+      CALL dynredem0("start.nc",dayref,phis)
       print*,'sortie dynredem0'
-      CALL dynredem1("start.nc",0.0,vvent,uvent,tpot,q3d,nqmx,masse ,
+      CALL dynredem1("start.nc",0.0,vvent,uvent,tpot,q3d,masse ,
      .                            psol)
       print*,'sortie dynredem1' 
@@ -742,6 +748,6 @@
       visu_file='Etat0_visu.nc'
       CALL initdynav(visu_file,dayref,anneeref,time_step,
-     .              t_ops, t_wrt, nqmx, visuid)
-      CALL writedynav(visuid, nqmx, itau,vvent ,
+     .              t_ops, t_wrt, visuid)
+      CALL writedynav(visuid, itau,vvent ,
      .                uvent,tpot,pk,phi,q3d,masse,psol,phis)
       else
@@ -750,4 +756,7 @@
       print*,'entree histclo'
       CALL histclo
+
+      DEALLOCATE(q3d)
+
       RETURN
       !
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/fluxstokenc.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/fluxstokenc.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/fluxstokenc.F	(revision 1114)
@@ -56,5 +56,5 @@
 	CALL initfluxsto( 'fluxstoke',
      .  time_step,istdyn* time_step,istdyn* time_step,
-     . nqmx, fluxid,fluxvid,fluxdid) 
+     .  fluxid,fluxvid,fluxdid) 
 	
 	ndex(1) = 0
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/gcm.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/gcm.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/gcm.F	(revision 1114)
@@ -11,4 +11,5 @@
 
       USE filtreg_mod
+      USE infotrac
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -70,5 +71,4 @@
 #include "iniprint.h"
 #include "tracstoke.h"
-#include "advtrac.h"
 
       INTEGER         longcles
@@ -85,5 +85,5 @@
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
       REAL teta(ip1jmp1,llm)                 ! temperature potentielle 
-      REAL q(ip1jmp1,llm,nqmx)               ! champs advectes
+      REAL, ALLOCATABLE, DIMENSION(:,:,:):: q! champs advectes
       REAL ps(ip1jmp1)                       ! pression  au sol
       REAL p (ip1jmp1,llmp1  )               ! pression aux interfac.des couches
@@ -139,5 +139,5 @@
 c    variables pour l'initialisation de la physique :
 c    ------------------------------------------------
-      INTEGER ngridmx,nq
+      INTEGER ngridmx
       PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )
       REAL zcufi(ngridmx),zcvfi(ngridmx)
@@ -156,14 +156,4 @@
       dynhist_file = 'dyn_hist.nc'
       dynhistave_file = 'dyn_hist_ave.nc'
-
-c initialisation Anne
-      hadv_flg(:) = 0.
-      vadv_flg(:) = 0.
-      conv_flg(:) = 0.
-      pbl_flg(:)  = 0. 
-      tracnam(:)  = '        ' 
-      nprath = 1
-      nbtrac = 0
-      mmt_adj(:,:,:,:) = 1
 
 
@@ -217,5 +207,5 @@
 ! dynamique -> physique pour l'initialisation
 #ifdef CPP_PHYS
-      CALL Init_Phys_lmdz(iim,jjp1,llm,nqmx-2,1,(jjm-1)*iim+2)
+      CALL Init_Phys_lmdz(iim,jjp1,llm,1,(jjm-1)*iim+2)
       call InitComgeomphy
 #endif
@@ -224,5 +214,5 @@
       IF (config_inca /= 'none') THEN
 #ifdef INCA
-      call init_const_lmdz(nbtrac,anneeref,dayref,iphysiq,day_step,nday)
+      call init_const_lmdz(nbtr,anneeref,dayref,iphysiq,day_step,nday)
       call init_inca_para(iim,jjm+1,klon,1,klon_mpi_para_nb,0)
 #endif
@@ -239,9 +229,11 @@
 c   Initialisation des traceurs
 c   ---------------------------
-c  Choix du schema pour l'advection
-c  dans fichier trac.def ou via INCA
-
-       call iniadvtrac(nq)
-c
+c  Choix du nombre de traceurs et du schema pour l'advection
+c  dans fichier traceur.def, par default ou via INCA
+      call infotrac_init
+
+c Allocation de la tableau q : champs advectes   
+      allocate(q(ip1jmp1,llm,nqtot))
+
 c-----------------------------------------------------------------------
 c   Lecture de l'etat initial :
@@ -251,5 +243,5 @@
       if (read_start) then
 #ifdef CPP_IOIPSL
-         CALL dynetat0("start.nc",nqmx,vcov,ucov,
+         CALL dynetat0("start.nc",vcov,ucov,
      .              teta,q,masse,ps,phis, time_0)
 c       write(73,*) 'ucov',ucov
@@ -274,5 +266,5 @@
      .                 'AVANT iniacademic AVANT AVANT AVANT AVANT'
       if (.not.read_start) then
-         CALL iniacademic(nqmx,vcov,ucov,teta,q,masse,ps,phis,time_0)
+         CALL iniacademic(vcov,ucov,teta,q,masse,ps,phis,time_0)
       endif
 
@@ -396,5 +388,5 @@
 
 #ifdef CPP_IOIPSL
-      CALL dynredem0("restart.nc", day_end, phis, nqmx)
+      CALL dynredem0("restart.nc", day_end, phis)
 
       ecripar = .TRUE.
@@ -405,10 +397,10 @@
       t_wrt = iecri * daysec
       CALL inithist(dynhist_file,day_ref,annee_ref,time_step,
-     .              t_ops, t_wrt, nqmx, histid, histvid)
+     .              t_ops, t_wrt, histid, histvid)
 
       t_ops = iperiod * time_step
       t_wrt = periodav * daysec
       CALL initdynav(dynhistave_file,day_ref,annee_ref,time_step,
-     .              t_ops, t_wrt, nqmx, histaveid)
+     .              t_ops, t_wrt, histaveid)
 
       dtav = iperiod*dtvr/daysec
@@ -437,5 +429,5 @@
 
 
-      CALL leapfrog(ucov,vcov,teta,ps,masse,phis,nq,q,clesphy0,
+      CALL leapfrog(ucov,vcov,teta,ps,masse,phis,q,clesphy0,
      .              time_0)
 
